---
title: Programming in C
subtitle: Working with Text
layout: layouts/presentation.njk
---


<section>
  <section>
  <h2>Terminology</h2>
  <ul>
    <li>String</li>
    <li class="fragment">Standard input, standard output and standard error</li>
    <li class="fragment">Operator
      <ul>
        <li>A symbol representing an operation (eg.: mathematical operation)</li>
        <li>There are arithmetic, logical, assignment, ... operators</li>
      </ul>
    </li>
    <li class="fragment">Operator precedence
      <ul>
        <li>When in doubt, use parenthesis.</li>
        <li>In order to make your code more readable, use parenthesis.</li>
      </ul>
    </li>
    <li class="fragment"><code>while</code> loops</li>
  </ul>
  </section>

  <section>
  <h2>What is a String?</h2>
  <ul>
    <li>Sequence of characters
      <ul>
        <li>Details depend on the programming language</li>
      </ul>
    </li>
    <li>A C-string is a character array (<code>char[]</code>)</li>
    <li>C-strings are terminated with a character <code>'\0'</code></li>
  </ul>
  <div class="fragment">
{% highlight "c" %}
char text[] = "Freedom";
{% endhighlight %}
  <table class="memory" style="font-size: 50%">
    <tr>
      <th class="left">Index</th>
      <td>0</td>
      <td>1</td>
      <td>2</td>
      <td>3</td>
      <td>4</td>
      <td>5</td>
      <td>6</td>
      <td>7</td>
    </tr>
    <tr>
      <th>Value</th>
      <td>F</td>
      <td>r</td>
      <td>e</td>
      <td>e</td>
      <td>d</td>
      <td>o</td>
      <td>m</td>
      <td>\0</td>
    </tr>
    <tr>
      <th>Address</th>
      <td>0x7fffc8c013e4</td>
      <td>0x7fffc8c013e5</td>
      <td>0x...e6</td>
      <td>0x...e7</td>
      <td>0x...e8</td>
      <td>0x...e9</td>
      <td>0x...ea</td>
      <td>0x...eb</td>
    </tr>
  </table>
  {% include_code "source/c/strings/what_is_a_string.c" %}
  </div>
  </section>
</section>

<section>
  <h2>Purpose of Working with Text</h2>

  <section>
  <h3>Which problems do C strings solve?</h3>
  <ul>
    <li>Input/output (I/O) required for basic communication with users</li>
    <li>User interaction requires text</li>
    <li>Prerequisite for reading and writing textual files</li>
    <li>...</li>
  </ul>
  </section>

  <section>
  <h3>Which problems do C strings cause?</h3>
  <ul>
    <li>C strings are "dumb" (not even aware of their length)</li>
    <li>Limited to extended ASCII</li>
    <li>Hard to use compared to higher level languages</li>
    <li><strong>Security</strong> implications of C string functions</li>
  </ul>
  </section>
</section>

<section>
  <h2>Reading User Input</h2>
  <section>
    <p>I/O functions are included via <code>stdio.h</code></p>
    <ul>
      <li><code>scanf(.)</code> can read user input, but has security problems</li>
      <li>Some compilers offer <code>scanf_s(.)</code>
        <ul>
          <li>non-standard and hence not portable</li>
        </ul>
      </li>
      <li>Solution: <code>fgets(.)</code> + <code>sscanf(.)</code>
        <ul>
          <li><code>fgets(char *s, int size, FILE *stream)</code> reads in at
            most one less than size characters;
            includes final newline</li>
          <li><code>sscanf(const char *str, const char *format, ...)</code>
            scans input according to format</li>
        </ul>
      </li>
    </ul>
  </section>

  <section>
    <h3>Example: Read a Single Number</h3>
{% highlight "c 3,6,8" %}
{% include "source/c/strings/read_number.c" %}
{% endhighlight %}
    <p>{% download '/data/c/strings/read_number.c' %}</p>
  </section>

  <section>
    <h3>Example: Read Two Numbers</h3>
{% highlight "c 3,6,8" %}
{% include "source/c/strings/read_numbers.c" %}
{% endhighlight %}
    <p>{% download '/data/c/strings/read_numbers.c' %}</p>
  </section>

  <section>
    <h3>Example: Read a String</h3>
    <p><code>fgets(.)</code> also includes the final newline (if it fits
      the size of the buffer)</p>
{% highlight "c 6,8" %}
{% include "source/c/strings/read_string.c" %}
{% endhighlight %}
    <p>{% download '/data/c/strings/read_string.c' %}</p>
  </section>

</section>

<section>
  <h2>String Functions</h2>
  <section>
    <p>String functions are included via <code>string.h</code> and
      <code>strings.h</code></p>
    <p>Using string functions may lead to <strong>security</strong> issues.</p>
    <p><code>stpcpy, strcasecmp, strcat, strchr, strcmp, strcoll, strcpy,
      strcspn, strdup, strfry, strlen, strncat, strncmp, strncpy, strncasecmp,
      strpbrk, strrchr, strsep, strspn, strstr, strtok, strxfrm, index,
      rindex</code></p>
    <p>To get help, consult your manual :)</p>
{% highlight "bash" %}
man 3 string
{% endhighlight %}

  <p class="fragment">
    <code>toupper(int c)</code> and <code>tolower(int c)</code> are included
     via <code>ctype.h</code>
  </p>
  </section>

  <section>
    <h3>Example: Copy a String</h3>
{% highlight "c 6" %}
{% include "source/c/strings/copy_string.c" %}
{% endhighlight %}
{% include_code "source/c/strings/copy_string.c" %}
  </section>
</section>

{# Branching #}
{# Loops #}
<section>
  <h2>Iterating Over a String</h2>
  <section>
    <p>It is possible to iterate over a string using a <code>while</code>
      loop. The syntax is<p>
{% highlight "c" %}
while (condition) {
  // statements that repeat as long as `condition` evaluates to true
}
{% endhighlight %}

  <div class="fragment">
    <p>Loops can be interrupted with <code>break</code>.<br />
     The current iteration can be ended using <code>continue</code>.</p>
{% highlight "c" %}
while (condition) {
  // block of statements
  if (skip_remaining_iteration) {
    continue;  // skip rest of this iteration
  }
  if (loop_should_end_now) {
    break;  // leave the loop
  }
}
{% endhighlight %}
  </div>
  </section>

  <section>
    <h3>Example: Convert String to Upper Case</h3>
{% highlight "c 6" %}
{% include "source/c/strings/to_upper.c" %}
{% endhighlight %}
{% include_code "source/c/strings/to_upper.c" %}
  </section>
</section>

{% include 'slides/closing.njk' %}
